/***********************************************************
    lorenz.c -- Lorenz () ȥ饯
    ʸ:
    ¼ɧCˤǿ르ꥺŵסʵɾҡ
***********************************************************/
#include <stdio.h>
#include <handy.h>

#define  WSIZE    300.0
#define  SCALE    5.0
#define  A        10.0
#define  B        28.0
#define  C        (8.0 / 3.0)
#define  D        0.01

int main(int argc, char **argv)
{
    int k;
    double x, y, z, dx, dy, dz;
    int    id1, id2, id3;

    id1 = HgWOpen(40.0, 90.0, WSIZE, WSIZE);
    id2 = HgWOpen(WSIZE+60.0, 90.0, WSIZE, WSIZE);
    id3 = HgWOpen(WSIZE*2+80.0, 90.0, WSIZE, WSIZE);
    if (id1 < 0 || id2 < 0 || id3 < 0) {
        printf("Can't create windows\n");
        return 1;
    }

    HgWCoordinate(id1, WSIZE/2.0, WSIZE/2.0, SCALE);
    HgWCoordinate(id2, WSIZE/2.0, 0.0, SCALE);
    HgWCoordinate(id3, WSIZE/2.0, 0.0, SCALE);
    x = y = z = 1.0;
    for (k = 0; k < 3200; k++) {
        dx = A * (y - x);
        dy = x * (B - z) - y;
        dz = x * y - C * z;
        x += D * dx;  y += D * dy;  z += D * dz;
        if (k > 100) {
            HgWLineTo(id1, x, y);
            HgWLineTo(id2, x, z);
            HgWLineTo(id3, y, z);
        }else if (k == 100) {
            HgWMoveTo(id1, x, y);
            HgWMoveTo(id2, x, z);
            HgWMoveTo(id3, y, z);
        }
    }
    printf("End (Type Return)");
    fflush(stdout);
    (void)getchar();
    HgCloseAll();
    return 0;
}
