#include <stdio.h>
#include <handy.h>

char buf[100];

int main(int argc, char *argv[])
{
    if (argc < 2) {
        fprintf(stderr, "Usage: a.out sound-file [volume]\n");
        fprintf(stderr, "Option: volume = 1 - 9\n");
        return 1;
    }
    hgsound sid = HgSoundLoad(argv[1]);
    if (sid == HG_ERROR) {
        fprintf(stderr, "Error: can't read sound file.\n");
        return 2;
    }
    if (argc > 2) {
        int d = argv[2][0];
        if (d > '0' && d <= '9') {
            double v = (double)(d - '0') / 10.0;
            HgSoundVolume(sid, v*v, 0);
        }
    }
    printf("p:Play, s:Stop, return:Pause/Resume, q:Quit\n");

    int pause = 0;
    while (fgets(buf, 100, stdin) != NULL) {
        switch (buf[0]) {
        case 'p': HgSoundPlay(sid); break;
        case 's': HgSoundStop(sid); break;
        case '\n':
        case '\r':
            if (pause) {
                HgSoundResume(sid);
            }else {
                HgSoundPause(sid);
            }
            pause = 1 - pause;
            break;
        case 'q':
            HgSoundUnload(sid);
            return 0;
        default:
            HgBeep();
            break;
        }
    }
    return 0;
}
